/*
 *
 *  Copyright (C) 2007-2020 SimplyCore, LLC
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *
 */

#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/slab.h>
#include <linux/ioctl.h>
#include <linux/usb.h>
#include <linux/types.h>
#include <linux/fs.h>
#include <linux/cdev.h>
#include <linux/poll.h>
#include <linux/spinlock.h>
#include <linux/list.h>
#include <linux/version.h>
#include <linux/kref.h>
#include <linux/device.h>
#include <linux/compat.h>
#include <linux/mm.h>
#include <linux/vmalloc.h>
#include <linux/module.h>
#include <asm/uaccess.h>
#define KERNEL_GT(IlIlIll,lIlIIlI,IlIIlIIl)			(LINUX_VERSION_CODE > \
KERNEL_VERSION((IlIlIll),(lIlIIlI),(IlIIlIIl)))
#define KERNEL_LT(IlIlIll,lIlIIlI,IlIIlIIl)			(LINUX_VERSION_CODE < \
KERNEL_VERSION((IlIlIll),(lIlIIlI),(IlIIlIIl)))
#define KERNEL_EQ(IlIlIll,lIlIIlI,IlIIlIIl)			(LINUX_VERSION_CODE == \
KERNEL_VERSION((IlIlIll),(lIlIIlI),(IlIIlIIl)))
#define KERNEL_GT_EQ(IlIlIll,lIlIIlI,IlIIlIIl)			(LINUX_VERSION_CODE >= \
KERNEL_VERSION((IlIlIll),(lIlIIlI),(IlIIlIIl)))
#define KERNEL_LT_EQ(IlIlIll,lIlIIlI,IlIIlIIl)			(LINUX_VERSION_CODE <= \
KERNEL_VERSION((IlIlIll),(lIlIIlI),(IlIIlIIl)))
#if defined(RHEL_RELEASE_CODE) 
#define RHEL_RELEASE_GT(IlIlIll,lIlIIlI) 		(RHEL_RELEASE_CODE > \
RHEL_RELEASE_VERSION((IlIlIll),(lIlIIlI)))
#define RHEL_RELEASE_LT(IlIlIll,lIlIIlI)		(RHEL_RELEASE_CODE < \
RHEL_RELEASE_VERSION((IlIlIll),(lIlIIlI)))
#define RHEL_RELEASE_EQ(IlIlIll,lIlIIlI)		(RHEL_RELEASE_CODE == \
RHEL_RELEASE_VERSION((IlIlIll),(lIlIIlI)))
#define RHEL_RELEASE_GT_EQ(IlIlIll,lIlIIlI)		(RHEL_RELEASE_CODE >= \
RHEL_RELEASE_VERSION((IlIlIll),(lIlIIlI)))
#define RHEL_RELEASE_LT_EQ(IlIlIll,lIlIIlI)		(RHEL_RELEASE_CODE <= \
RHEL_RELEASE_VERSION((IlIlIll),(lIlIIlI)))
#else
#define RHEL_RELEASE_GT(IlIlIll,lIlIIlI) 		(0x1bfd+550-0x1e23)
#define RHEL_RELEASE_LT(IlIlIll,lIlIIlI)		(0x5c1+4046-0x158f)
#define RHEL_RELEASE_EQ(IlIlIll,lIlIIlI)		(0x88a+2296-0x1182)
#define RHEL_RELEASE_GT_EQ(IlIlIll,lIlIIlI)		(0xde2+4017-0x1d93)
#define RHEL_RELEASE_LT_EQ(IlIlIll,lIlIIlI)		(0x1152+4244-0x21e6)
#endif

#ifndef BUS_ID_SIZE
#define BUS_ID_SIZE (0x1e54+1452-0x23ec)
#endif
#include "../public/pubstt2.h"
#include "../public/apitypes.h"
#include "../public/pubuniprotocol.h"
#include "../public/interface.h"
#include "../public/public_devices.h"
#include "utils.h"
#include "driver.h"
#include "cdev.h"
#include "stub.h"
#include "vhci.h"
#include "minor_loader.h"
#include "minor_stub.h"
#include "minor_vbus.h"
#include "minor_vstub.h"
#include "urb_chain.h"
#include "sg.h"

#if KERNEL_LT_EQ((0x18bd+2208-0x215b),(0x736+3050-0x131a),(0xe7b+4302-0x1f3a))
#define llIlllIII __stringify(KBUILD_MODNAME)
#else
#define llIlllIII KBUILD_MODNAME
#endif

#ifndef CONFIG_PRINTK_TIME
#define IIIlIlll(lIIllll, IIIIlIl...) printk(KERN_DEBUG \
"\x5b\x25\x30\x39\x75\x5d\x20\x25\x73\x3a\x20" lIIllll, jiffies_to_msecs(jiffies\
), llIlllIII, ## IIIIlIl)
#else
#define IIIlIlll(lIIllll, IIIIlIl...) printk(KERN_DEBUG "\x25\x73\x3a\x20" \
lIIllll, llIlllIII, ## IIIIlIl)
#endif

#define llIIlIIII(IIlIllIl,IIllllIII,IIlIIlII) do { \
	char IlllIlIl[(0x1110+4718-0x231a)]; \
	char *lIIllIIl; \
	size_t i; \
	for(i=(0x5f7+4419-0x173a),lIIllIIl=IlllIlIl;i<(IIlIIlII);i++) \
	{ \
		if((i%(0x3f6+1095-0x835)) == (0x276+2761-0xd3f) && i > (0x3f0+2700-0xe7c)) \
		{ \
			Illll(IIlIllIl "\x25\x73" "\n", IlllIlIl); \
			lIIllIIl=IlllIlIl; \
		} \
		sprintf(lIIllIIl,"\x25\x30\x32\x58\x20", (IIllllIII)[i]); \
		lIIllIIl+=(0x3b8+6234-0x1c0f); \
	} \
	if(lIIllIIl!=IlllIlIl) IIIlIlll(IIlIllIl "\x25\x73" "\n", IlllIlIl); \
} while ((0xe0d+2468-0x17b1))

#define IlIIIlIII(IIlIllIl,IIllllIII,IIlIIlII) do { \
	char IlllIlIl[(0x275+8530-0x2363)]; \
	char *lIIllIIl; \
	size_t i; \
	for(i=(0x355+614-0x5bb),lIIllIIl=IlllIlIl;(i<(IIlIIlII))&&(i<\
(0xb64+3495-0x18eb));i++,lIIllIIl+=(0x976+4293-0x1a38)) \
	{ \
		sprintf(lIIllIIl,"\x25\x30\x32\x58\x20", ((unsigned char*)(IIllllIII))[i]); \
	} \
	if(i>(0xb1a+4219-0x1b95)) {IIIlIlll(IIlIllIl "\x20\x25\x73\x25\x73" "\n", \
IlllIlIl, (i<(IIlIIlII)) ? "\x2e\x2e\x2e" : "");} \
} while ((0x18f9+1628-0x1f55))

#ifdef _USBD_DEBUG_
#define Illll(lIIllll, IIIIlIl...) IIIlIlll(lIIllll, ##IIIIlIl)
#define IIlll(lIIllll, IIIIlIl...) IIIlIlll("\x25\x73\x3a\x20" lIIllll, __func__\
, ##IIIIlIl)
#define lllIIllII(IllIIlIl,lIllllII,IIlIllll) llIIlIIII(IllIIlIl,lIllllII,\
IIlIllll)
#define IIlIlIlll(IllIIlIl,lIllllII,IIlIllll) IlIIIlIII(IllIIlIl,lIllllII,\
IIlIllll)
#else
#define Illll(lIIllll, IIIIlIl...) do {} while((0x1748+463-0x1917))
#define IIlll(lIIllll, IIIIlIl...) do {} while((0x10cf+5551-0x267e))
#define lllIIllII(IllIIlIl,lIllllII,IIlIllll) do {} while((0x596+709-0x85b))
#define IIlIlIlll(IllIIlIl,lIllllII,IIlIllll) do {} while((0x4d7+4201-0x1540))
#endif

#define llIlII(lIIllll, IIIIlIl...) IIIlIlll(lIIllll, ##IIIIlIl)
#define IIllIIlIlI(IllIIlIl,lIllllII,IIlIllll) llIIlIIII(IllIIlIl,lIllllII,\
IIlIllll)
#define lllIlIlIl(IllIIlIl,lIllllII,IIlIllll) IlIIIlIII(IllIIlIl,lIllllII,\
IIlIllll)
extern size_t lIIIIll;
#if KERNEL_LT_EQ((0xf7+6686-0x1b13),(0x6c2+1967-0xe6b),(0x655+783-0x94d))
typedef unsigned long uintptr_t;
#endif
#if KERNEL_LT_EQ((0x7f1+1689-0xe88),(0xce5+1632-0x133f),(0x19c+6955-0x1cb8))
#define atomic_xchg(lIIlllIIIl, new) (xchg(&((lIIlllIIIl)->counter), new))
#endif
#if KERNEL_LT((0x81d+2974-0x13b8),(0x1f53+626-0x21b3),(0x93f+5587-0x1f12))




#undef strncasecmp
#define strncasecmp strnicmp
#endif

